;; Utils
(define-macro (with var val . body)
  `(let ((,var ,val)) . ,body))
   ;; extracted & hacked from src/TeXmacs/progs/kernel/boot/abbrevs.scm

;; Socket functions
(sigaction SIGPIPE (lambda (sig) #t)) ;; NOTE: Mandatory if we want to be
                                      ;;   able to catch the socket errors.
(define-macro (new-socket host port)
  `(if (equal? ,host "")
       (with sock (socket AF_INET SOCK_STREAM 0)
          (bind sock AF_INET INADDR_ANY ,port)
          (listen sock 3)
          sock
       )
       (with sock (socket AF_INET SOCK_STREAM 0)
       (with addr (car (vector-ref (gethostbyname ,host) 4))
          (connect sock AF_INET addr ,port)
          sock)))
)
(define-macro (socket-accept sock)
  `(car (accept ,sock))
)
(define-macro (socket-read sock)
  `(with s (read-line ,sock)
      (with-input-from-string s
         (lambda () (read))))
)
(define-macro (socket-write sock obj)
  `(with vobj ,obj
      (with-output-to-port ,sock
         (lambda ()
            (write vobj)
            (newline)
            (force-output))))
)
(define-macro (socket-close sock)
  `(close-port ,sock)
)

;; Server
(define (process-request-1 sock)
   (let ((s (socket-read sock)))
        (socket-write sock (query sock s))
        s
   )
)
(define (process-request-2 sock cmd)
   (socket-write sock cmd)
   (socket-read sock)
)
(define finished #f)
(define (server1 port)
  (let ((srv (new-socket ""  port)
       ))
       (do ((n0 0)
           )
           (finished 0)
           (do ((s (socket-accept srv))
                (n 0)
                (next #f)
                (msg '())
               )
               ;((or (eof-reached s) finished) 0)
               ((or next finished) 0)
               (set! msg (process-request-1 s))
              ;(display "Server(")
               (write n0)
              ;(display ";")
              ;(write n)
              ;(display ")=")
               (display "=")
               (set! n (+ n 1))
              ;(if (strsy-equal? msg "EOF")
                  (set! next 1)
              ;)
               (if (equal? msg "BYE")
                  (set! finished #t)
               )
               (write msg)
               (newline)
              ;(display "(Next,Finished)=(")
              ;(write next)
              ;(display ",")
              ;(write finished)
              ;(display ")")
              ;(newline)
           )
           (set! n0 (+ n0 1))
       )
  )
)
(define n 0)
(define (out msg)
  (display n)(display "=")
  (write msg)(newline)
  (set! n (+ 1 n))
)
(define (send-msg msg)
  (define s (new-socket "localhost" 1234))
  (process-request-2 s msg)
)
